package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

import javax.xml.xpath.XPathConstants;

import org.w3c.dom.NodeList;

import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;

/**
 * 
 *
 */
public class VirtualCollectionProxyAction extends WorkspaceAction {

	private static final long serialVersionUID = 1L;
	
	//private String proxy_key = "virtual_collection";
	
	//private String qid;
	//private String date;
	//private String datefrom;
	//private String dateto;
	/*
	public String getQid(){
		return qid;
	}
	public void setQid(String qid){
		this.qid = qid;
	}
	*/
	//@Override
	protected void  initialize(){
		//setFormat("VC");
	 }
	
	@Override 
	public String getFullFormat() {
		return "profile2" + getFormat();
	}
	
	//@Override
	//public String getProxyKey() {
	//	return proxy_key;
	//}
	
	public String getBaseURI() { 
		String uri = "file:/" + Cache.getCache().getCacheIndexPath();		
		return uri;
	}
	/*
	@Override
	public HashMap<String,String> createTransformerParams(){
		
		HashMap<String,String> hm = new HashMap<String,String>();
		
		if (getFullFormat() != null){
			hm.put("format", getFullFormat());
	    }
	    if (getQid() != null){
			hm.put("queryid", getQid());
	    }
        
		return hm;
		
	}
	*/
	public String publish() throws Exception {
		
		// find the workspace data
		NodeList list = (NodeList) WorkspaceProfile.getWorkspaceProfile().getWorkspaceData(
				WorkspaceProfile.getWorkspaceProfile().getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_WORKSPACE, this.getUserName()), 
				XPathConstants.NODESET); 
        InputStream is = Utils.document2Stream(list.item(0));
		//xslt transform to request data
		MDTransformer transformer = new MDTransformer();
		transformer.configure(Utils.getAppConfig("mdservice"), this.getClass().getClassLoader());
		transformer.setSrcFile(this.getTargetProxy().getTargetRequest());
		transformer.setParams(getParams());
		//transformer.setParams(createTransformerParams());
		InputStream requestStream = transformer.transformXML(is);
		
		java.io.Writer writer = new java.io.StringWriter(); 
		char[] buffer = new char[1024];             
		
		java.io.Reader reader = new BufferedReader(                         
		new InputStreamReader(requestStream, "UTF-8"));                 
		int n;                 
		while ((n = reader.read(buffer)) != -1) {                     
			writer.write(buffer, 0, n); 
		} 
	
		//create connection and post request data
		// find out 
		//"http://clarin.ids-mannheim.de/vcr/service/virtualcollection";
		String urlstring = Utils.getConfig("virtualcollection.uri");
		String vcrstr = (String)getVcrid();//getQueryVcrid();
		if (!vcrstr.equals("0")){
			urlstring = urlstring + "/" + vcrstr;
		}
		//qlist.item(0).get
        URL url = new URL(urlstring);
        String charset = "UTF-8"; 
        URLConnection urlconn = url.openConnection();
        HttpURLConnection conn = (HttpURLConnection) urlconn;
        conn.setDoOutput(true);
        conn.setDoInput(true); 
        conn.setRequestMethod("POST");
        String encoding = new sun.misc.BASE64Encoder().encode("test1@ids-mannheim.de:test1234".getBytes());
        conn.setRequestProperty("Authorization", "Basic " + encoding);
        conn.setRequestProperty("Content-Type", "text/xml;charset=" + charset);//; charset=utf-8");
        conn.setRequestProperty("Accept-Charset", charset); 
        //System.setProperty("http.keepAlive", "false");
        //conn.setRequestMethod("GET");
        //conn("Expect", "100-continue"); 
        //System.setProperty("http.agent", "");
        
    	OutputStreamWriter out = new OutputStreamWriter(
                                  conn.getOutputStream());
    	out.write(writer.toString());
    	out.flush();
    	out.close();
    	
       	InputStream responseStream; 
        	
       	Integer respCode = conn.getResponseCode();
       	if (respCode == 200 || respCode == 201) {  
        	    responseStream = conn.getInputStream(); 
        	    //conn.getContent();
        } else {    
        		responseStream = conn.getErrorStream(); 
        } 
        	  
        setResultStream(responseStream);
        
		return SUCCESS;
	}
	
}
