package eu.clarin.cmdi.mdservice.model;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;

import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import net.sf.json.JSON;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import net.sf.json.JSONSerializer;
import net.sf.json.xml.XMLSerializer;
import eu.clarin.cmdi.mdservice.internal.MDTransformer;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.action.FCSAction;
import eu.clarin.cmdi.mdservice.action.WorkspaceAction;
import eu.clarin.cmdi.mdservice.action.WorkspaceAction_old;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile_old.RepositoryType;

/**
 
 */



public class Options{	

	private static Options singleton;
	private static NodeList options_nodelist;
	

	
	public Options() {
		if (options_nodelist == null){
			Init();
		}
	}
	
	
	public static Options getOptions() {
		if (singleton == null) {
			singleton = new Options();
		} 
		return singleton;
	}
	
	public void Init(){
		WorkspaceProfile wsp = WorkspaceProfile.getWorkspaceProfile();
		try {
			options_nodelist = (NodeList ) wsp.getWorkspaceData(
					wsp.getXPathExpressionDummy(WorkspaceProfile.XPATH_EXPR_OPTIONS, WorkspaceProfile.SERVER),
					XPathConstants.NODESET);
		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public InputStream getXMLStream() throws TransformerConfigurationException, TransformerException, TransformerFactoryConfigurationError{
		
		return Utils.document2Stream(options_nodelist.item(0));
		
	}

//TODO
	public String getOption(String string) {
		// TODO Auto-generated method stub
		return null;
	}


	
}


